datablock AudioProfile(tf2shotgunReloadSound)
{
   filename    = "./tf2shotgunReload.wav";
   description = AudioClosest3d;
   preload = true;
};

AddDamageType("TF2Shotgun",   '<bitmap:Add-Ons/Weapon_TF2BasicGuns/CI_TF2Shotgun> %1',    '%2 <bitmap:Add-Ons/Weapon_TF2BasicGuns/CI_TF2Shotgun> %1',0.75,1);

//////////
// item //
//////////
datablock ItemData(tf2ShotgunItem)
{
   category = "Weapon";  // Mission editor category
   className = "Weapon"; // For inventory system
   
    // Basic Item Properties
   shapeFile = "./shotgun.dts";
   rotate = false;
   mass = 1;
   density = 0.2;
   elasticity = 0.2;
   friction = 0.6;
   emap = true;
   
   //gui stuff
   uiName = "TF2 Shotgun";
   iconName = "./icon_tf2shotgun";
   doColorShift = true;
   colorShiftColor = "0.5 0.5 0.5 1.000";
   
    // Dynamic properties defined by the scripts
   image = tf2ShotgunImage;
   canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(tf2ShotgunImage)
{
   // Basic Item properties
   shapeFile = "./shotgun.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0.10 0.1";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = tf2ShotgunItem;
   ammo = " ";
   projectile = gunProjectile;
   projectileType = Projectile;

   casing = gunShellDebris;
   shellExitDir        = "1.0 0.1 1.0";
   shellExitOffset     = "0 0 0";
   shellExitVariance   = 10.0;
   shellVelocity       = 5.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;
   minShotTime = "";

   doColorShift = true;
   colorShiftColor = tf2ShotgunItem.colorShiftColor;
   
   //Raycasting Weapons settings
   raycastWeaponRange = 1000;
   raycastWeaponTargets = $TypeMasks::FxBrickObjectType |	//Targets the weapon can hit: Raycasting Bricks
   				$TypeMasks::PlayerObjectType |	//AI/Players
   				$TypeMasks::StaticObjectType |	//Static Shapes
   				$TypeMasks::TerrainObjectType |	//Terrain
   				$TypeMasks::VehicleObjectType;	//Vehicles
   raycastWeaponPierceTargets = "";				//Gun cannot pierce
   raycastExplosionProjectile = gunprojectile;
   raycastExplosionSound = ""; //sound played by exploding gunprojectile
   raycastDirectDamage = 11;
   raycastDirectDamageType = $DamageType::TF2Shotgun;
   raycastSpreadCount = 5;
   raycastSpreadAmt = 0.0035;
   raycastTracerProjectile = TF2BulletTrailProjectile;
   raycastImpactImpulse = 0;

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]				= "Activate";
	stateTimeoutValue[0]			= 0.2;
	stateWaitForTimeout[0]			= true;
	stateTransitionOnTimeout[0]		= "LoadGun";
	stateSound[0]				= weaponSwitchSound;
	
	stateName[1]				= "Ready";
	stateTransitionOnTriggerDown[1]		= "Fire";
	stateAllowImageChange[1]		= true;
	stateTimeoutValue[1]			= 0.01;
	
	stateName[2]                    	= "Fire";
	stateTransitionOnTimeout[2]     	= "Loadgun_Smoke";
	stateTimeoutValue[2]            	= 0.3;
	stateFire[2]                    	= true;
	stateAllowImageChange[2]        	= false;
	stateSequence[2]                	= "Fire";
	stateScript[2]                  	= "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]				= gunFlashEmitter;
	stateEmitterTime[2]			= 0.05;
	stateEmitterNode[2]			= "muzzleNode";
	stateSound[2]				= gunShot1Sound;
	stateEjectShell[2]       		= true;
	
	stateName[3] 				= "Loadgun_Smoke";
	stateEmitter[3]				= gunSmokeEmitter;
	stateEmitterTime[3]			= 0.1;
	stateEmitterNode[3]			= "muzzleNode";
	stateTimeoutValue[3]			= 0.4;
	stateSequence[3]			= "Reload";
	stateSound[3]				= tf2shotgunReloadSound;
	stateWaitForTimeout[3]			= true;
	stateTransitionOnTimeout[3]		= "Ready";
	
	stateName[4] 				= "Loadgun";
	stateTimeoutValue[4]			= 0.4;
	stateSequence[4]			= "Reload";
	stateSound[4]				= tf2shotgunReloadSound;
	stateWaitForTimeout[4]			= false;
	stateTransitionOnTimeout[4]		= "Ready";
	stateTransitionOnTriggerDown[4]	= "Fire";
};

function tf2ShotgunImage::onFire(%this,%obj,%slot)
{
	Parent::onFire(%this,%obj,%slot);
	%obj.playThread(2, shiftAway);
}

function tf2ShotgunImage::onReload(%this,%obj,%slot)
{
	%obj.playThread(2, plant);
}